%global sum \
Distributed Communication-Optimal Matrix-Matrix Multiplication Library

Name:		cosma
Version:	2.6.2
Release:	1%{?dist}
Summary:	%summ
License:	BSD-3-Clause
URL:		https://github.com/eth-cscs/COSMA
Source0:	https://github.com/eth-cscs/COSMA/releases/download/v%version/cosma.tar.gz
BuildRequires:	cmake > 3, gcc-c++, openblas-devel

%global desc \
COSMA is a parallel, high-performance, GPU-accelerated, matrix-matrix\
multiplication algorithm that is communication-optimal for all\
combinations of matrix dimensions, number of processors and memory\
sizes, without the need for any parameter tuning. The key idea behind\
COSMA is to first derive a tight optimal sequential schedule and only\
then parallelize it, preserving I/O optimality between processes.\
\
This packaging has no GPU support.

%description
%desc

%package openmpi
BuildRequires: openmpi-devel, scalapack-openmpi-devel
Summary: %summ - openmpi

%description openmpi
%desc

This is the openmpi version.

%package openmpi-devel
BuildRequires: openmpi-devel, scalapack-openmpi-devel
Summary: Development files for %name-openmpi
Requires: openmpi-devel%_isa, scalapack-openmpi-devel%_isa
Requires: %name-openmpi%_isa = %version-%release

%description openmpi-devel
Development files for %name-openmpi.

This is the openmpi version.

%prep
%autosetup -n cosma


%build
mkdir ompi
cd ompi
%_openmpi_load
%cmake -DCOSMA_BLAS=OPENBLAS -DBUILD_SHARED_LIBS=ON \
   -DSCALAPACK_BLAS=OPENBLAS -DCMAKE_INSTALL_PREFIX=$MPI_HOME \
   -DINCLUDE_INSTALL_DIR=$MPI_INCLUDE -DCOSMA_WITH_TESTS=OFF \
   -DCOSMA_WITH_APPS=OFF -DCOSMA_WITH_BENCHMARKS=OFF ..
%make_build -j1
cd ..
%_openmpi_unload


%install
%_openmpi_load
cd ompi
%cmake_install
cd ..
%_openmpi_unload


%files openmpi
%license LICENSE
%doc README.md ATTRIBUTIONS.md
%_libdir/openmpi/%_lib/libcosma.so
%_libdir/openmpi/%_lib/libcosta.so
%exclude %_libdir/openmpi/include/*
%exclude %_libdir/openmpi/%_lib/cmake

%files openmpi-devel
%_libdir/openmpi/include/cosma
%_libdir/openmpi/include/costa
%dir %_libdir/openmpi/%_lib/cmake
%_libdir/openmpi/%_lib/cmake/cosma
%_libdir/openmpi/%_lib/cmake/costa
%_libdir/openmpi/%_lib/pkgconfig/*.pc



%changelog
* Mon Nov 14 2022 Dave Love <loveshack@fedoraproject.org>
- Initial packaging
